 /*----------------------------------------------------------------------*
 *	CLASS:	 	Preview.js
 *
 *	ORIGINATOR:	aig
 *	CREATION DATE:	Thu Apr 29 11:09:53 PDT 1999
 *
 *----------------------------------------------------------------------*

/**
 * This file defines client-side JavaScript objects for the previewe command
 */

    // notebook tab styles
    var SELECTED_TAB_BACKGROUND_COLOR 		= "#d4d0c8";
    var SELECTED_TAB_COLOR 			= "black";
    var SELECTED_TAB_BORDER_STYLE 		= "solid";
    var SELECTED_TAB_BORDER_COLOR 		= "#666600";
    var SELECTED_TAB_BORDER_WIDTH 		= "3";
    var UNSELECTED_TAB_BACKGROUND_COLOR 	= "#7d7d7d";
    var UNSELECTED_TAB_COLOR 			= "white";
    var UNSELECTED_TAB_BORDER_STYLE 		= "solid";
    var UNSELECTED_TAB_BORDER_COLOR 		= "gray";
    var UNSELECTED_TAB_BORDER_WIDTH 		= "1";

    var NORMAL_FONT_FAMILY	= null;



    var	DOWN_KEY 		                    = 40;
    var	UP_KEY			                    = 38;
    var HOME_KEY                            = 36;
    var END_KEY                             = 35;

   /*-------------------------------------------------------------------*
    *	Constructor:	fixefoxResize
    *	ORIGINATOR:	dlf
    *	CREATION DATE:	4/2/2002
    *-------------------------------------------------------------------*/
   /**
    * Called when the user resizes the browser on firefox
    *
    */


    function firefoxResize()
    {
	for (var name in window.namesToComponents)
	    {
	    var	comp = window.namesToComponents[name];

	    if (comp.resize)
	    	{
		comp.resize();
		}
	    }

    }
   /*-------------------------------------------------------------------*
    *	Constructor:	NotebookPageDescriptor
    *	ORIGINATOR:	dlf
    *	CREATION DATE:	4/2/2002
    *-------------------------------------------------------------------*/
   /**
    * Constructor for an object that describes a page in a notebook
    *
    * @param    pageId			The id of this page
    * @param	pageTitle		The display title of this page
    */


    function NotebookPageDescriptor(
        pageId,
	pageTitle
        )
    {

	this.pageId          = pageId;
	this.pageTitle       = pageTitle;
	this.pageDiv		 = null;
	this.notebookId		 = null;
	this.notebookDiv	 = null;
	this.pageButton		 = null;
	this.isCurrentPage	 = null;
            
    } 

function getNamedStyle(styleName)
{
	styleName = styleName.toLowerCase();
	if (document.styleSheets && document.styleSheets.length > 0)
	{
	var rules = null;
	var str = "";

	for (var sheetnum = 0; sheetnum < document.styleSheets.length; sheetnum++)
	    {
	    if (document.styleSheets[sheetnum].rules)
		    {
		    rules = document.styleSheets[sheetnum].rules;
		    }
	    else if (document.styleSheets[sheetnum].cssRules)
		    {
		    rules = document.styleSheets[sheetnum].cssRules;
		    }
	    for (var idx=0; rules != null && idx< rules.length; idx++)
		    {
		    var rule = rules[idx];
		    if (rule.selectorText.toLowerCase() == "."+styleName)
			    {
			    //alert(str);
			    return rule.style;
			    }
		    str += "skip " + rule.selectorText.toLowerCase() + "\n";
		    }
	    }

	//alert(str);
	}
	return null;

}

function initPreview(resizeBrowser, screenLeft, screenTop, systemIconBase, projectIconBase)
{

    
    var	isIE = navigator.appName.indexOf("Microsoft") != -1;

    window.projectIconBase = projectIconBase;
    window.systemIconBase = systemIconBase;
    window.showNotebookPage = doShowNotebookPage;

    if (!isIE)
	{
	window.onresize = firefoxResize;
	}

	// position browser
	// both left & top defined, use moveTo
	if (screenLeft != undefined && screenLeft != -1 
		&& screenLeft < window.screen.width
		&& screenTop != undefined && screenTop != -1
		&& screenTop < window.screen.height)
		{
		window.top.moveTo(screenLeft, screenTop);
		}
	// top is undefined, use moveBy(x, 0)
	else if (screenLeft != undefined && screenLeft != -1
		&& screenLeft < window.screen.width)	
		{
		var curScreenLeft = (window.top.screenLeft ? window.top.screenLeft : window.top.screenX);
		if (isIE)		// adjust for browser frame
			curScreenLeft -= 5;
		window.top.moveBy(screenLeft-curScreenLeft, 0);
		}
	// left is undefined, use moveBy(0,y)
	else if (screenTop != undefined && screenTop != -1
		&& screenTop < window.screen.height)
		{
		var curScreenTop = (window.top.screenTop ? window.top.screenTop : window.top.screenY);
		if (isIE)	// adjust for browser's toolbar sizes
			curScreenTop -= 100;
		window.top.moveBy(0, screenTop - curScreenTop);
		}

	// setup mouse over handlers
	var images = window.document.getElementsByTagName("input");
	for (var idx=0; idx < images.length; idx++)
		{
		if (images[idx].type == "image")
			{
			var image = images[idx];
			if (!isIE && !image.rolloverimage)
			    image.rolloverimage = image.getAttribute('rolloverimage');

			image.origImage = image.src;
			if (image.rolloverimage)
			    {
			    image.onmouseover = new Function("this.src=this.rolloverimage;");
			    image.onmouseout = new Function("this.src=this.origImage;");
			    }
			}
		}
	var links = window.document.anchors;
	if (!isIE)
	    links = window.document.getElementsByTagName('A');
	for (var idx=0; idx < links.length; idx++)
		{
		var images = links[idx].getElementsByTagName("IMG");
		if (images.length == 1)
			{
			var image = images[0]
			if (!isIE && !links[idx].rolloverimage)
			    links[idx].rolloverimage = links[idx].getAttribute('rolloverimage');

			image.rolloverimage = links[idx].rolloverimage;
			image.origImage = image.src;
			if (image.rolloverimage)
			    {
			    image.onmouseover = new Function("this.src=this.rolloverimage;");
			    image.onmouseout = new Function("this.src=this.origImage;");
			    }
			}
		}

	if (resizeBrowser)
		{
		window.isIE = isIE;
		window.doResizeBrowser = doResizeBrowser;
		window.setTimeout("window.doResizeBrowser();", 250);
		}

    // Initialize the grids
    
	for (var idx = 0; idx < window.grids.length; idx++)
	    {
	    window.grids[idx].initializeGrid();
	    }
    // fixup file chooser controls for netscape
    if (!isIE)
	{
	var choosers = window.document.getElementsByTagName('INPUT');
	for (var idx=0; idx<choosers.length; idx++)
	    {
	    if (choosers[idx].type == 'file')
		{
		var size=Math.floor((choosers[idx].offsetWidth-94)/6);
		choosers[idx].size = size;
		}
	    }
	}

    // apply row style and alt row style for repeating areas
    var allDivs = window.document.getElementsByTagName("DIV");
    for (var idx=0; idx<allDivs.length; idx++)
	{
	if (allDivs[idx].id && allDivs[idx].id.indexOf("RepeatingArea1.") != -1)
	    {
	    var rowStyle = allDivs[idx].getAttribute("rowStyle");
	    var altRowStyle = allDivs[idx].getAttribute("altRowStyle");
	    var elements = allDivs[idx].getElementsByTagName("INPUT");
	    for (var jdx=0; jdx<elements.length; jdx++)
		{
		var field = elements[jdx];
		var row = 0;
		var dot = field.name.indexOf('.');
		if (dot != -1 && dot != field.name.length-1)
		    {
		    row = parseInt(field.name.substr(dot+1))+1;
		    }
		if (!isNaN(row))
		    {
		    var style = altRowStyle;
		    if ((row %2) == 0)
			{
			style = rowStyle;
			}
		    if (style && field.className.indexOf(style) == -1)
			{
			field.className += " "+style;
			}
		    }
		}
	    }
	}
    if (!isIE)
	{
	var box;
	var allFieldSets = window.document.getElementsByTagName('FIELDSET');
	for (var idx = 0; idx < allFieldSets.length; idx++) 
	    {
	    box = allFieldSets[idx];
	    // Workaround netscape box size bug - tweak by border width
	    if (box.id
		&& box.style.borderStyle
		&& box.style.borderStyle != "none"
		&& box.style.borderWidth)
		{
		var borderWidth = parseInt(box.style.borderWidth);
		if (!isNaN(borderWidth) && borderWidth >0)
		    {
		    var height = parseInt(box.style.height);
		    var width = parseInt(box.style.width);
		    if (!isNaN(height) && !isNaN(width))
			{
			height -= 2*borderWidth;
			width -= 2*borderWidth;
			box.style.width = (width)+"px";
			box.style.height = (height)+"px";
			}
		    }
		}
	    // Adjust top of children by fontSize if there is a legend.
	    var legends = box.getElementsByTagName('LEGEND');
	    if (legends.length)
		{
		var	style = window.document.defaultView.getComputedStyle(box,'');
		var fontSize = style.getPropertyValue('font-size');
		if (fontSize)
		    {
		    var div;
		    for (var cidx=0; cidx<box.childNodes.length; cidx++)
			{
			div = box.childNodes[cidx];
			if (div.tagName == 'DIV'
			    && div.style.position == "absolute"
			    && div.style.top)
			    {
			    div.style.top =
				parseInt(div.style.top)-parseInt(fontSize);
			    }
			}
		    }
		}
	    }
	}
    // Move horizontol rule up by 7 pixels for IE
    if (isIE)
	{
	var hrs = this.document.getElementsByTagName('HR');
	for (var idx = 0; idx < hrs.length; idx++) 
	    {
	    hrs[idx].style.marginTop = "-7px";
	    }
	}

}

function doShowNotebookPage(pageButton)
{
    var parentNotebookDiv = null;
    var	isIE = navigator.appName.indexOf("Microsoft") != -1;

    for (var idx=0; idx<window.notebookPages.length; idx++)
	{
	var pageDesc = window.notebookPages[idx];

	if (pageButton == pageDesc.pageButton)
	    {
	    parentNotebookDiv = pageDesc.notebookDiv;
	    break;
	    }
	}
	
    var unselectedTabStyle = getNamedStyle("UNSELECTED_TAB_HEADER");
    var selectedTabStyle = getNamedStyle("SELECTED_TAB_HEADER");

    var	unselectedTabImage = null;
    var	selectedTabImage = null;

    if (unselectedTabStyle && unselectedTabStyle.backgroundImage)
	{
	var		icon = unselectedTabStyle.backgroundImage;
	var		lparen = icon.indexOf('(');
	var		rparen = icon.indexOf(')');

	if (lparen != -1 && rparen != -1 && lparen < rparen)
	    {
	    unselectedTabImage = icon.substring(lparen + 1, rparen);
	    }
	else
	    {
	    unselectedTabImage = icon;
	    }

	if (unselectedTabImage == "winxptabinactive.gif")
	    {
	    unselectedTabImage =  "url(" + window.systemIconBase + "/"   + unselectedTabImage + ")";
	    }
	else
	    {
	    unselectedTabImage = "url("  + window.projectIconBase + "/"  + unselectedTabImage + ")";
	    }
	}
			    
    if (selectedTabStyle && selectedTabStyle.backgroundImage)
	{
	var		icon = selectedTabStyle.backgroundImage;
	var		lparen = icon.indexOf('(');
	var		rparen = icon.indexOf(')');

	if (lparen != -1 && rparen != -1 && lparen < rparen)
	    {
	    selectedTabImage = icon.substring(lparen + 1, rparen);
	    }
	else
	    {
	    selectedTabImage = icon;
	    }

	if (selectedTabImage == "winxptabactive.gif")
	    {
	    selectedTabImage =  "url(" + window.systemIconBase + "/" +  selectedTabImage + ")";
	    }
	else
	    {
	    selectedTabImage = "url(" + window.projectIconBase + "/" +  selectedTabImage + ")";
	    }
	}
			    
    for (var idx=0; idx<window.notebookPages.length; idx++)
	{
	var pageDesc = window.notebookPages[idx];

	if (pageDesc.notebookDiv == parentNotebookDiv)
	    {
	    if (pageDesc.pageButton == pageButton)
		{
		pageDesc.pageDiv.style.display = "inline";

		var	gotImage = false;


		if (selectedTabImage)
		    {
		    try
			{
			pageDesc.pageButton.parentNode.style.backgroundImage = selectedTabImage;
			pageDesc.pageButton.parentNode.style.backgroundRepeat = "repeat";

			gotImage = true;
			}
		    catch (exc)
			{
			}
		    }

		if (!gotImage)
		    {
		    if (selectedTabStyle && selectedTabStyle.borderStyle)
			    pageDesc.pageButton.parentNode.style.borderStyle = selectedTabStyle.borderStyle;
		    else
			    pageDesc.pageButton.parentNode.style.borderStyle = SELECTED_TAB_BORDER_STYLE;

		    if (selectedTabStyle && selectedTabStyle.borderWidth)
			    pageDesc.pageButton.parentNode.style.borderWidth = selectedTabStyle.borderWidth;
		    else
			    pageDesc.pageButton.parentNode.style.borderWidth = SELECTED_TAB_BORDER_WIDTH;

		    if (selectedTabStyle && selectedTabStyle.borderColor)
			    pageDesc.pageButton.parentNode.style.borderColor = selectedTabStyle.borderColor;
		    else
			    pageDesc.pageButton.parentNode.style.borderColor = SELECTED_TAB_BORDER_COLOR;

		    if (selectedTabStyle && selectedTabStyle.backgroundColor)
			    pageDesc.pageButton.parentNode.style.backgroundColor = selectedTabStyle.backgroundColor;
		    else
			    pageDesc.pageButton.parentNode.style.backgroundColor = SELECTED_TAB_BACKGROUND_COLOR;
		    if (selectedTabStyle && selectedTabStyle.color)
			    pageDesc.pageButton.style.color = selectedTabStyle.color;
		    else
			    pageDesc.pageButton.style.color = SELECTED_TAB_COLOR;
		    }

		if ( ! isIE)		// extra tweak for NS
		    {
		    var saveStyle = pageButton.parentNode.style.display;
		    pageButton.parentNode.style.display = "none";
			if (selectedTabStyle && selectedTabStyle.color)
			    pageDesc.pageButton.style.color = selectedTabStyle.color;
			else
			    pageDesc.pageButton.style.color = SELECTED_TAB_COLOR;
		    pageButton.parentNode.style.display = saveStyle;
		    }

		if (selectedTabStyle && selectedTabStyle.fontFamily)
			pageDesc.pageButton.style.fontFamily = selectedTabStyle.fontFamily;
		if (selectedTabStyle && selectedTabStyle.fontSize)
			pageDesc.pageButton.style.fontSize = selectedTabStyle.fontSize;
		if (selectedTabStyle && selectedTabStyle.fontWeight)
			pageDesc.pageButton.style.fontWeight = selectedTabStyle.fontWeight;
		if (selectedTabStyle && selectedTabStyle.fontStyle)
			pageDesc.pageButton.style.fontStyle = selectedTabStyle.fontStyle;

		pageDesc.pageButton.parentNode.style.textDecoration = "none";
		pageDesc.pageButton.parentNode.style.borderBottomStyle = "none";

		pageDesc.isCurrentPage = true;
		//pageButton.blur();
		}
	    else
		{
		pageDesc.pageDiv.style.display = "none";

		var	gotImage = false;

		if (unselectedTabImage)
		    {
		    try
			{
			pageDesc.pageButton.parentNode.style.backgroundImage = unselectedTabImage;
			pageDesc.pageButton.parentNode.style.backgroundRepeat = "repeat";
			gotImage = true;
			}
		    catch (exc)
			{
			}
		    }

		if (!gotImage)
		    {
		    if (unselectedTabStyle && unselectedTabStyle.borderStyle) 
			    pageDesc.pageButton.parentNode.style.borderStyle = unselectedTabStyle.borderStyle;
		    else
			    pageDesc.pageButton.parentNode.style.borderStyle = UNSELECTED_TAB_BORDER_STYLE;

		    if (unselectedTabStyle && unselectedTabStyle.borderColor) 
			    pageDesc.pageButton.style.borderColor = unselectedTabStyle.borderColor;
		    else
			    pageDesc.pageButton.parentNode.style.borderColor = UNSELECTED_TAB_BORDER_COLOR;

		    if (unselectedTabStyle && unselectedTabStyle.borderWidth) 
			    pageDesc.pageButton.parentNode.style.borderWidth = unselectedTabStyle.borderWidth;
		    else
			    pageDesc.pageButton.parentNode.style.borderWidth = UNSELECTED_TAB_BORDER_WIDTH;	
   
		    if (unselectedTabStyle && unselectedTabStyle.backgroundColor) 
			    pageDesc.pageButton.parentNode.style.backgroundColor = unselectedTabStyle.backgroundColor;
		    else
			    pageDesc.pageButton.parentNode.style.backgroundColor = UNSELECTED_TAB_BACKGROUND_COLOR;

		    if (unselectedTabStyle && unselectedTabStyle.color)
			    pageDesc.pageButton.style.color = unselectedTabStyle.color;		
		    else
			    pageDesc.pageButton.style.color = UNSELECTED_TAB_COLOR;		

		    }

		pageDesc.pageButton.style.fontFamily = pageDesc.unselectedFontFamily;
		pageDesc.pageButton.style.fontSize = pageDesc.unselectedFontSize;

		if (unselectedTabStyle && unselectedTabStyle.fontWeight)
			pageDesc.pageButton.style.fontWeight = unselectedTabStyle.fontWeight;
		else if (isIE && selectedTabStyle && selectedTabStyle.fontWeight)
			pageDesc.pageButton.style.fontWeight = parentNotebookDiv.currentStyle.fontWeight;
		if (unselectedTabStyle && unselectedTabStyle.fontStyle)
			pageDesc.pageButton.style.fontStyle = unselectedTabStyle.fontStyle;
		else if (isIE && selectedTabStyle && selectedTabStyle.fontStyle)
			pageDesc.pageButton.style.fontStyle = parentNotebookDiv.currentStyle.fontStyle;
				
		pageDesc.pageButton.parentNode.style.textDecoration = "none";
		pageDesc.pageButton.parentNode.style.borderBottomStyle = "none";


		pageDesc.isCurrentPage = false;
		}
	    }
	}

}

function doResizeBrowser()
{
	var frameset = window.top;
	var form = window.document.forms.NXJForm;

	var formHeight = parseInt(form.style.height);
	var formWidth = parseInt(form.style.width);
	if (frameset != null
		&& ! isNaN(formHeight)
		&& ! isNaN(formWidth))
		{
		var screenLeft;
		var screenTop;
		if (window.isIE)
			{
			screenLeft = window.top.screenLeft;
			screenTop = window.top.screenTop;
			}
		else
			{
			screenLeft = window.top.screenX + (window.top.outerWidth-window.top.innerWidth);
			screenTop = window.top.screenY + (window.top.outerHeight-window.top.innerHeight);
			}
		var maxWidth = window.screen.availWidth - screenLeft;
		var maxHeight = window.screen.availHeight - screenTop;

		var rowHeight = 0;
		var borderWidth = parseInt(form.style.borderWidth);
		if (! isNaN(borderWidth))
			{
			rowHeight += borderWidth;
			if (! window.isIE)
				rowHeight += borderWidth;
			}
		rowHeight += formHeight;
		if (rowHeight > maxHeight)
			rowHeight = maxHeight;

		var targetHeight = rowHeight - frameset.document.body.clientHeight;

		var colWidth = 0;
		colWidth += formWidth;
		if (! isNaN(borderWidth))
			{
			colWidth += borderWidth;
			if (! window.isIE)
				colWidth += borderWidth;
			}

		if (colWidth > maxWidth)
			colWidth = maxWidth;

		var targetWidth = colWidth - frameset.document.body.clientWidth;

		window.top.resizeBy(targetWidth,targetHeight);
		}
}
   /*-------------------------------------------------------------------*
    *	Constructor:	GridDescriptor
    *	ORIGINATOR:	dlf
    *	CREATION DATE:	4/2/2002
    *-------------------------------------------------------------------*/
   /**
    * Constructor for an object that describes a grid.  The object's
    * initializeGrid method initializes the grid itself.
    *
    * @param    key             The id for the grid
    * @param	nrows           The number of rows in the grid.
    * @param    ncols           The number of columns in the grid.
    *                           This may include a dummy column if the
    *                           leftmost field in the repeating area
    *                           is not at the left edge of the grid.
    * @param    dummy           Indicates that there is a dummy column.
    * @param    selClass        The style class for selected rows
    */

    function GridDescriptor(
    	key,
	    nrows,
	    ncols,
	    dummy,
	    selClass
	    )
    {

	    this.key             = key;
	    this.nrows           = nrows;
	    this.ncols           = ncols;
	    this.hasDummy        = dummy;
	    this.selClass        = selClass;
	    this.initializeGrid  = doInitializeGrid;

   }

   /*-------------------------------------------------------------------*
    *	METHOD:         doInitializeGrid
    *	ORIGINATOR:	    aig
    *	CREATION DATE:	4/2/2002
    *-------------------------------------------------------------------*/
   /**
    * This method is called from initPreview.  It finds the div
    * for the grid, stores some state information in the grid,
    * and sets up the event handlers for all the cells.
    */

   function doInitializeGrid()
   {

	    var	grid = document.all[this.key];

	    grid.ncols           = this.ncols;
	    grid.nrows           = this.nrows;
	    grid.selClass        = this.selClass;
	    grid.selRow          = -1;
    	
	    grid.onkeydown = new Function("", "return false");	

	    for (var row = 0; row < this.nrows; row++)
	        {
	        for (col = 0; col < this.ncols; col++)
	    	    {
		        var	divKey = grid.id + "." + row + "." + col;
		        var	div = document.all[divKey];
		        
		        if (div == null) 
		            {
		            alert("no div for " + divKey);
		            }
		            
		        div.onclick   = gridOnClick;
                div.onkeydown = gridOnKeyDown;		                          
		        }
	        }
	        
    }


   /*-------------------------------------------------------------------*
    *	METHOD:         gridOnClick
    *	ORIGINATOR:	    aig
    *	CREATION DATE:	4/2/2002
    *-------------------------------------------------------------------*/
   /**
    * onClick method for grid cells.
    */

    function gridOnClick()
    {
        
        // Parse the id to find the row then call gridSelectRow.
        
	    var	div = document.all[this.id];    
	    var	grid = div.parentNode;
	    
	    var lastDot = this.id.lastIndexOf(".");
	    var prefix  = this.id.substr(0, lastDot);
	    var prevDot = prefix.lastIndexOf('.');
	    var rowStr = prefix.substring(prevDot + 1);

	    gridSelectRow(grid, parseInt(rowStr));

    }
    
   /*-------------------------------------------------------------------*
    *	METHOD:         gridOnKeyDown
    *	ORIGINATOR:	    aig
    *	CREATION DATE:	4/2/2002
    *-------------------------------------------------------------------*/
   /**
    * onKeyDown method for grid cells.
    */

    
    function gridOnKeyDown(
        event
        ) 
    {

	    var	isIE = navigator.appName.indexOf("Microsoft") != -1;
        
        if (isIE) 
            {
            event = window.event;        
            }
            
	    var	    grid = this.parentNode;            
	    var     keyCode = event.keyCode;

	    if (keyCode == DOWN_KEY && grid.selRow < grid.nrows)
	        {
	        gridSelectRow(grid, grid.selRow + 1);
	        }
	    else if (keyCode == UP_KEY && grid.selRow > 0)
	        {
	        gridSelectRow(grid, grid.selRow - 1);
	        }
	    else if (keyCode == HOME_KEY && grid.selRow != 0)
	        {
	        gridSelectRow(grid, 0);
	        }
	    else if (keyCode == END_KEY && grid.selRow != grid.nrows - 1)
	        {
	        gridSelectRow(grid, grid.nrows - 1);
	        }

	    return false;

    }

   /*-------------------------------------------------------------------*
    *	METHOD:         gridSelectRow
    *	ORIGINATOR:	    aig
    *	CREATION DATE:	4/2/2002
    *-------------------------------------------------------------------*/
   /**
    * Select a row in the grid.  If the newly selected row is not visible
    * then scroll it into view.
    */


    function gridSelectRow(
    	grid,
    	row
	    )
    {

        // If there was a selected row then restore its
        // style.
        
	    if (grid.selRow != -1)
	        {
	        for (var col = 0; col < grid.ncols; col++)
		        {
		        var	oldKey = grid.id 
			        + "."
			        + grid.selRow
			        + "."
			        + col;

		        var	oldDiv = document.all[oldKey];

		        oldDiv.className = grid.savedClass;
		        }
	        }

	    grid.selRow = row;

        // Update the styles for the newly selected row.  When you
        // process the first column, save the style and do any
        // necessary scrolling.
        
	    for (var col = 0; col < grid.ncols; col++)
	        {
	        var	key = grid.id 
		        + "."
		        + grid.selRow
		        + "."
		        + col;

	        var	adiv = document.all[key];

	        if (col == 0)
	    	    {
		        grid.savedClass = adiv.className;

		        var	    scrollTop = grid.scrollTop;
		        var	    scrollBottom = scrollTop + grid.style.pixelHeight - 1;
		        var	    adivTop = adiv.style.pixelTop;
		        var	    adivBottom = adivTop + adiv.style.pixelHeight - 1;


		        if (adivTop < scrollTop)
		            {
		            grid.scrollTop -= adiv.style.pixelHeight;
		            }
		        else if (adivBottom > scrollBottom)
		            {
		            grid.scrollTop += adiv.style.pixelHeight;
		            }
		        }

	        adiv.className = grid.selClass;
	        }
    }
function associateObjWithEvent(obj, methodName){
    return (function(e){
        e = e||window.event;
        return obj[methodName](e, this);
    });
}

