<?xml version="1.0"?> 

<!-- This stylesheet is used to create the ibm-ejb-jar-ext.xmi
     file from the ejb-jar.xml file.
  -->

<xsl:stylesheet
  xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
  xmlns:lxslt="http://xml.apache.org/xslt"
  version="1.0">

<xsl:output
  method="xml"
  encoding="UTF-8"
  indent="yes"
/>


<ejbext:EJBJarExtension
 xmi:version="2.0"
 xmlns:xmi="http://www.omg.org/XMI"
 xmlns:ejbext="ejbext.xmi"
 xmlns:ejb="ejb.xmi"
 xmi:id="ejb-jar_ID_Ext">

  <ejbJar href="META-INF/ejb-jar.xml#ejb-jar_ID"/>
  <ejbExtensions xmi:type="ejbext:SessionExtension" xmi:id="Session_1_Ext" timeout="600">
    <enterpriseBean xmi:type="ejb:Session" href="META-INF/ejb-jar.xml#Session_1"/>
    <structure xmi:id="BeanStructure_1" inheritenceRoot="false"/>
    <beanCache xmi:id="BeanCache_1" activateAt="ONCE"/>
    <internationalization xmi:id="BeanInternationalization_1" invocationLocale="CALLER"/>
    <localTran xmi:id="LocalTran_1" boundary="BEAN_METHOD" unresolvedAction="ROLLBACK"/>
  </ejbExtensions>
</ejbext:EJBJarExtension>



<xsl:template match="/">
  <ejbext:EJBJarExtension xmi:version="2.0"
        xmlns:xmi="http://www.omg.org/XMI"
        xmlns:ejbext="ejbext.xmi"
        xmlns:ejb="ejb.xmi">
    <xsl:attribute name='id' namespace="http://www.omg.org/XMI">
      <xsl:value-of select="concat(ejb-jar/@id, '_Ext')"/>
    </xsl:attribute>
    <ejbJar>
      <xsl:attribute name='href'>
        <xsl:value-of select="concat('META-INF/ejb-jar.xml#', ejb-jar/@id)"/>
      </xsl:attribute>
    </ejbJar>

    <xsl:apply-templates select="*"/>

  </ejbext:EJBJarExtension>
</xsl:template>

<xsl:template match="text()">
</xsl:template>

<xsl:template match="enterprise-beans/*">
  <ejbExtensions>
    <xsl:attribute name='id' namespace="http://www.omg.org/XMI">
      <xsl:value-of select="concat(@id, '_Ext')"/>
    </xsl:attribute>
    <xsl:choose>
      <xsl:when test="local-name()='entity'">\
        <xsl:attribute name='timeout'>0</xsl:attribute>
        <xsl:attribute name='type' namespace="http://www.omg.org/XMI">ejbext:EntityExtension</xsl:attribute>
      </xsl:when>
      <xsl:when test="local-name()='session'">
        <xsl:attribute name='timeout'>0</xsl:attribute>
        <xsl:attribute name='type' namespace="http://www.omg.org/XMI">ejbext:SessionExtension</xsl:attribute>
      </xsl:when>
      <xsl:when test="local-name()='message-driven'">
        <xsl:attribute name='type' namespace="http://www.omg.org/XMI">ejbext:MessageDrivenExtension</xsl:attribute>
      </xsl:when>
    </xsl:choose>

    <enterpriseBean>
      <xsl:attribute name='href'>
        <xsl:value-of select="concat('META-INF/ejb-jar.xml#', @id)"/>
      </xsl:attribute>
      <xsl:choose>
        <xsl:when test="local-name()='entity'">
          <xsl:attribute name='type' namespace="http://www.omg.org/XMI">ejb:Entity</xsl:attribute>
        </xsl:when>
        <xsl:when test="local-name()='session'">
          <xsl:attribute name='type' namespace="http://www.omg.org/XMI">ejb:Session</xsl:attribute>
        </xsl:when>
        <xsl:when test="local-name()='message-driven'">
          <xsl:attribute name='type' namespace="http://www.omg.org/XMI">ejb:MessageDriven</xsl:attribute>
        </xsl:when>
      </xsl:choose>
    </enterpriseBean>

    <structure inheritenceRoot="false">
      <xsl:attribute name='id' namespace="http://www.omg.org/XMI">
        <xsl:value-of select="concat('BeanStructure_', position())"/>
      </xsl:attribute>
    </structure>

    <internationalization invocationLocale="CALLER">
      <xsl:attribute name='id' namespace="http://www.omg.org/XMI">
        <xsl:value-of select="concat('BeanInternationalization_', position())"/>
      </xsl:attribute>
    </internationalization>

    <xsl:apply-templates select="resource-ref" mode="enterprise-beans">
      <xsl:with-param name="currentEjbName" select="ejb-name/text()"/>
    </xsl:apply-templates>

  </ejbExtensions>
</xsl:template>

<xsl:template match="resource-ref" mode="enterprise-beans">
  <xsl:param name="currentEjbName" select="''"/>
  <resourceRefExtensions>
    <xsl:attribute name='id' namespace="http://www.omg.org/XMI">
      <xsl:value-of select="concat(@id, '_Ext')"/>
    </xsl:attribute>
    <xsl:attribute name='isolationLevel'>TRANSACTION_READ_COMMITTED</xsl:attribute>
    <resourceRef>
      <xsl:attribute name='href'>
        <xsl:value-of select="concat('META-INF/ejb-jar.xml#', @id)"/>
      </xsl:attribute>
    </resourceRef>
  </resourceRefExtensions>
</xsl:template>

</xsl:stylesheet>

