<?xml version="1.0"?> 

<!-- This stylesheet is used to create the ibm-web-bnd.xmi
     file from the web.xml file.
  -->

<xsl:stylesheet
  xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
  xmlns:lxslt="http://xml.apache.org/xslt"
  xmlns:ux="com.unify.nxj.jasxform.XalanExtension"
  extension-element-prefixes="ux"
  exclude-result-prefixes="ux"
  version="1.0">

<xsl:output
  method="xml"
  encoding="UTF-8"
  indent="yes"
/>

<lxslt:component prefix="ux"
    functions="getWarJndiNameForEjbRef">
  <lxslt:script lang="javaclass"
    src="com.unify.nxj.jasxform.XalanExtension"/>
</lxslt:component>

<xsl:param name="options" />

<xsl:template match="/">
  <webappbnd:WebAppBinding
        xmi:version="2.0"
        xmlns:xmi="http://www.omg.org/XMI"
        xmlns:webappbnd="webappbnd.xmi"
        xmlns:webapplication="webapplication.xmi"
        xmlns:commonbnd="commonbnd.xmi"
        xmlns:common="common.xmi">
    <xsl:attribute name='id' namespace="http://www.omg.org/XMI">
      <xsl:value-of select="concat(web-app/@id, '_Bnd')"/>
    </xsl:attribute>
    <webapp>
      <xsl:attribute name='href'>
        <xsl:value-of select="concat('WEB-INF/web.xml#', web-app/@id)"/>
      </xsl:attribute>
    </webapp>

    <xsl:apply-templates select="*"/>

  </webappbnd:WebAppBinding>
</xsl:template>

<xsl:template match="text()">
</xsl:template>

<xsl:template match="ejb-ref">
  <ejbRefBindings>
    <xsl:attribute name='id' namespace="http://www.omg.org/XMI">
      <xsl:value-of select="concat(@id, '_Bnd')"/>
    </xsl:attribute>
    <xsl:attribute name='jndiName'>
      <xsl:value-of select=
        "ux:getJndiNameForEjbRef($options, '', ejb-ref-name/text())"/>
    </xsl:attribute>
    <bindingEjbRef>
      <xsl:attribute name='href'>
        <xsl:value-of select="concat('WEB-INF/web.xml#', @id)"/>
      </xsl:attribute>
    </bindingEjbRef>
  </ejbRefBindings>
</xsl:template>

<xsl:template match="ejb-local-ref">
  <ejbRefBindings>
    <xsl:attribute name='id' namespace="http://www.omg.org/XMI">
      <xsl:value-of select="concat(@id, '_Bnd')"/>
    </xsl:attribute>
    <xsl:attribute name='jndiName'>
      <xsl:value-of select=
        "ux:getJndiNameForEjbLocalRef($options, '', ejb-ref-name/text())"/>
    </xsl:attribute>
    <bindingEjbRef>
      <xsl:attribute name='href'>
        <xsl:value-of select="concat('WEB-INF/web.xml#', @id)"/>
      </xsl:attribute>
    </bindingEjbRef>
  </ejbRefBindings>
</xsl:template>

<xsl:template match="resource-ref">
  <resRefBindings>
    <xsl:attribute name='id' namespace="http://www.omg.org/XMI">
      <xsl:value-of select="concat(@id, '_Bnd')"/>
    </xsl:attribute>
    <xsl:attribute name='jndiName'>
      <xsl:value-of select=
        "ux:getJndiNameForResourceRef($options, '', res-ref-name/text())"/>
    </xsl:attribute>
    <bindingResourceRef>
      <xsl:attribute name='href'>
        <xsl:value-of select="concat('WEB-INF/web.xml#', @id)"/>
      </xsl:attribute>
    </bindingResourceRef>
  </resRefBindings>
</xsl:template>

</xsl:stylesheet>
