<?xml version="1.0"?> 

<!-- This stylesheet is used to create the ibm-web-ext.xmi
     file from the web.xml file.
  -->

<xsl:stylesheet
  xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
  xmlns:lxslt="http://xml.apache.org/xslt"
  xmlns:xmi="http://www.omg.org/XMI"
  version="1.0">

<xsl:output
  method="xml"
  encoding="UTF-8"
  indent="yes"
/>

<xsl:template match="/">
  <webappext:WebAppExtension xmi:version="2.0"
        xmlns:xmi="http://www.omg.org/XMI"
        xmlns:webappext="webappext.xmi"
        xmlns:webapplication="webapplication.xmi"
        reloadInterval="0"
        reloadingEnabled="false">
    <xsl:attribute name='id' namespace="http://www.omg.org/XMI">
      <xsl:value-of select="concat(web-app/@id, '_Ext')"/>
    </xsl:attribute>
    <webApp>
      <xsl:attribute name='href'>
        <xsl:value-of select="concat('WEB-INF/web.xml#', web-app/@id)"/>
      </xsl:attribute>
    </webApp>

    <xsl:apply-templates select="*"/>

  </webappext:WebAppExtension>
</xsl:template>

<xsl:template match="text()">
</xsl:template>

<!-- Special case for gluecode web app. -->
<xsl:template match="servlet[@id='Servlet_jetspeed']">
  <extendedServlets xmi:id="ServletExt_jetspeed">
    <extendedServlet href="WEB-INF/web.xml#Servlet_jetspeed"/>
    <localTransaction xmi:id="LocalTransaction_jetspeed" unresolvedAction="Commit"/>
  </extendedServlets>
</xsl:template>

<xsl:template match="resource-ref">
  <resourceRefExtensions>
    <xsl:attribute name='id' namespace="http://www.omg.org/XMI">
      <xsl:value-of select="concat(@id, '_Ext')"/>
    </xsl:attribute>
    <xsl:attribute name='isolationLevel'>TRANSACTION_READ_COMMITTED</xsl:attribute>
    <resourceRef>
      <xsl:attribute name='href'>
        <xsl:value-of select="concat('WEB-INF/web.xml#', @id)"/>
      </xsl:attribute>
    </resourceRef>
  </resourceRefExtensions>
</xsl:template>

</xsl:stylesheet>
