<?xml version="1.0"?> 

<!-- This stylesheet is used to generate a jboss-web.xml file from
     a web.xml file and data provided from the XalanExtension.
  -->

<xsl:stylesheet
  xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
  xmlns:lxslt="http://xml.apache.org/xslt"
  xmlns:ux="com.unify.nxj.jasxform.JBossXalanExtension"
  extension-element-prefixes="ux"
  exclude-result-prefixes="ux"
  version="1.0">

<xsl:output
  method="xml"
  encoding="UTF-8"
  indent="yes"
/>

<lxslt:component prefix="ux"
    functions="getJndiNameForEjbRef getJndiNameForResourceRef getContextPath">
  <lxslt:script lang="javaclass"
    src="com.unify.nxj.jasxform.JBossXalanExtension"/>
</lxslt:component>

<xsl:param name="doc-type" />
<xsl:param name="options" />

<xsl:template match="/">
  <xsl:value-of select="$doc-type" disable-output-escaping="yes" />
  <jboss-web>
    <context-root>
      <xsl:value-of select="ux:getContextPath($options)"/>
    </context-root>
    <xsl:apply-templates select="*"/>
  </jboss-web>
</xsl:template>

<xsl:template match="text()">
</xsl:template>

<xsl:template match="resource-ref">
  <resource-ref>
    <res-ref-name>
      <xsl:value-of select="res-ref-name/text()"/>
    </res-ref-name>
    <jndi-name>
      <xsl:value-of select=
        "ux:getJndiNameForResourceRef($options, '', res-ref-name/text())"/>
    </jndi-name>
  </resource-ref>
</xsl:template>

<xsl:template match="resource-env-ref">
  <resource-env-ref>
    <resource-env-ref-name>
      <xsl:value-of select="resource-env-ref-name/text()"/>
    </resource-env-ref-name>
    <jndi-name>
      <xsl:value-of select=
        "ux:getJndiNameForResourceEnvRef($options, '', resource-env-ref-name/text())"/>
    </jndi-name>
  </resource-env-ref>
</xsl:template>

<xsl:template match="ejb-ref">
  <ejb-ref>
    <ejb-ref-name>
      <xsl:value-of select="ejb-ref-name/text()"/>
    </ejb-ref-name>
    <jndi-name>
      <xsl:value-of select=
        "ux:getJndiNameForEjbRef($options, '', ejb-ref-name/text())"/>
    </jndi-name>
  </ejb-ref>
</xsl:template>

<xsl:template match="ejb-local-ref">
  <ejb-local-ref>
    <ejb-ref-name>
      <xsl:value-of select="ejb-ref-name/text()"/>
    </ejb-ref-name>
    <local-jndi-name>
      <xsl:value-of select=
        "ux:getJndiNameForEjbLocalRef($options, '', ejb-ref-name/text())"/>
    </local-jndi-name>
  </ejb-local-ref>
</xsl:template>


</xsl:stylesheet>
