<?xml version="1.0"?> 

<!-- This stylesheet is used to transform the an application.xml
     file to application-inprise.xml. Basically, this script
     removes the context-root element from the xml file.
  -->

<xsl:stylesheet
  xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
  xmlns:lxslt="http://xml.apache.org/xslt"
  version="1.0">

<xsl:output
  method="xml"
  encoding="UTF-8"
  indent="yes"
/>

<xsl:param name="doc-type" />

<xsl:template match="/">
  <xsl:value-of select="$doc-type" disable-output-escaping="yes" />
  <orion-application deployment-version="9.0.2.0.0">
    <xsl:apply-templates select="*"/>

    <persistence path="persistence"/>
    <library path="../lib"/>
    <log>
      <file path="{concat('../log/', application/display-name/text(), '.log')}" />
    </log>
    <namespace-access>
      <read-access>
        <namespace-resource root="">
          <security-role-mapping impliesAll="true" />
        </namespace-resource>
      </read-access>
      <write-access>
        <namespace-resource root="">
          <security-role-mapping />
        </namespace-resource>
      </write-access> 
    </namespace-access>
  </orion-application>
</xsl:template>

<xsl:template match="text()">
</xsl:template>

<xsl:template match="module/ejb">
  <ejb-module path="{text()}" remote="false" />
</xsl:template>

<xsl:template match="module/web/web-uri">
  <web-module id="{substring-before(text(), '.war')}" path="{text()}" />
</xsl:template>

<xsl:template match="module/web/context-root">
</xsl:template>

</xsl:stylesheet>
