<?xml version="1.0"?> 

<!-- This stylesheet is used to generate a orion-web.xml file from
     a web.xml file and some deploy-options.
  -->

<xsl:stylesheet
  xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
  xmlns:lxslt="http://xml.apache.org/xslt"
  xmlns:ux="com.unify.nxj.jasxform.OracleXalanExtension"
  extension-element-prefixes="ux"
  exclude-result-prefixes="ux"
  version="1.0">

<xsl:output
  method="xml"
  indent="yes"
/>

<lxslt:component prefix="ux"
    functions="getJndiNameForEjbRef getJndiNameForResourceRef">
  <lxslt:script lang="javaclass"
    src="com.unify.nxj.jasxform.OracleXalanExtension"/>
</lxslt:component>

<xsl:param name="options" />
<xsl:param name="doc-type" />


<xsl:template match="/">
  <xsl:value-of select="$doc-type" disable-output-escaping="yes" />
  <orion-web-app>
  <xsl:apply-templates select="*"/>
  <web-app-class-loader include-war-manifest-class-path="true" />
  </orion-web-app>
</xsl:template>

<xsl:template match="resource-ref">
    <resource-ref-mapping 
	name="{res-ref-name}" 
	location="{ux:getJndiNameForResourceRef($options, '', res-ref-name/text())}"/>
</xsl:template>

<xsl:template match="resource-env-ref">
    <resource-env-ref-mapping 
	name="{resource-env-ref-name}" 
	location="{ux:getJndiNameForResourceEnvRef($options, '', resource-env-ref-name/text())}"/>
</xsl:template>

<xsl:template match="ejb-ref">
  <xsl:if test="ejb-ref-name/text() != 'ejb/scheduler'">
      <ejb-ref-mapping
            name="{ejb-ref-name}"
            location="{ux:getJndiNameForEjbRef($options, '', ejb-ref-name/text())}" />
  </xsl:if>
</xsl:template>

<xsl:template match="ejb-local-ref">
  <ejb-ref-mapping
	name="{ejb-ref-name}"
	location="{ux:getJndiNameForEjbRef($options, '', ejb-link/text())}" />
</xsl:template>

<xsl:template match="text()">
</xsl:template>

<xsl:template match="web-app">
    <xsl:apply-templates select="*"/>
    <web-app>
	<xsl:copy-of select="servlet-mapping"/>
    </web-app>
</xsl:template>

</xsl:stylesheet>
