
##########################################################################
# Pointbase
##########################################################################

SELECT DISTINCT policy.label AS PolicyLabel, process.label AS ProcessLabel
FROM policy, process  
WHERE CHARACTER_LENGTH(policy.sourceCode) > 4000 
AND policy.process = process.realId 
AND    ( 
           ( 
           process.isDefinition = 1 
           AND process.label NOT LIKE '%!#)' 
           ) 
       OR  ( 
           process.isRoot = 1 
           AND process.state = 2 
           )
       );

##########################################################################
# MSSQL
##########################################################################

SELECT DISTINCT policy.label AS PolicyLabel, process.label AS ProcessLabel
FROM policy, process  
WHERE DATALENGTH(policy.sourceCode) > 4000 
AND policy.process = process.realId 
AND    ( 
           ( 
           process.isDefinition = 1 
           AND process.label NOT LIKE '%!#)' 
           ) 
       OR  ( 
           process.isRoot = 1 
           AND process.state = 2 
           )
       );

##########################################################################
# Oracle
##########################################################################

SELECT DISTINCT policy.label AS PolicyLabel, process.label AS ProcessLabel
FROM policy, process  
WHERE LENGTH(policy.sourceCode) > 4000 
AND policy.process = process.realId 
AND    ( 
           ( 
           process.isDefinition = 1 
           AND process.label NOT LIKE '%!#)' 
           ) 
       OR  ( 
           process.isRoot = 1 
           AND process.state = 2 
           )
       );

